window.zs = window.zs || {};
(function (exports, Laya) {
    class Native {
        static init() {
            let conchConfig = window['conchConfig'];
            if (conchConfig) {
                LayaNative.os = conchConfig.getOS();
                if (LayaNative.os == this.conchIOS) {
                    LayaNative.bridge = window['PlatformClass'].createClass('JSBridge');
                }
                else if (LayaNative.os == this.conchAndroid) {
                    LayaNative.bridge = window['PlatformClass'].createClass('zhise.JSBridge');
                    console.log("tribalWarPrint: init android bridge===========");
                }
            }

            let haveReviewApp = Laya.LocalStorage.getItem("haveReviewApp");
            console.log("zhise_laya_print:haveReviewApp="+haveReviewApp);
            if(haveReviewApp && haveReviewApp == "true"){
                console.log("已完成应用内评分");
            }else{
                console.log("zhise_laya_print","可以弹出评分弹窗");
                Laya.timer.once(3*60*1000,this,()=>{
                    this.ShowAppReview();
                })
            }
        }

        static get isReady() {
            return this.bridge != null;
        }

        static SendMessageToPlatform(thisAry, callback) {
            if (!this.isReady)
                return;
            let obj = {};
            this.bridge.callWithBack((value) => {
                if (callback) {
                    let jsonObj = JSON.parse(value);
                    callback.call(thisAry, jsonObj);
                }
            }, 'SendMessageToPlatform', JSON.stringify(obj));
        }

        static ShowBanner() {
            console.log("zhise_laya_print native.js ShowBanner")
            if (!this.isReady)
                return;
            this.bridge.call("ShowBanner")
        }

        static HideBanner() {
            console.log("zhise_laya_print native.js HideBanner")
            if (!this.isReady)
                return;
            this.bridge.call("HideBanner")
        }

        static PlayVideo(thisAry, callback) {
            console.log("zhise_laya_print native.js PlayVideo")
            if (!this.isReady) {
                callback({result:1});
                return;
            }
            // this.onAppHide();
            let obj = {};
            if(thisAry){
                obj.adPos = thisAry.adPos
            }
            this.bridge.callWithBack((value) => {
                console.log("JS层的视频回调", value)
                // this.onAppResume();
                console.log(value)
                if (callback) {
                    let jsonObj = JSON.parse(value);
                    callback.call(null, jsonObj);
                }
            }, 'PlayVideo', JSON.stringify(obj));
        }

        static ShowInsertAd(adPos) {
            console.log("zhise_laya_print native.js ShowInsertAd")
            let obj = {};
            if(adPos){
                obj.adPos = adPos
            }
            if (!this.isReady)
                return;
            this.bridge.call("ShowInsertAd",JSON.stringify(obj))
        }

        static PreloadAd() {
            console.log("预加载广告")
            if (!this.isReady)
                return;
            this.bridge.call('PreloadAd');
        }

        static AFTrackEvent(thisAry, callback){
            if(!this.isReady){
                return;
            }
            let obj = {}
            if(thisAry){
                let eventName = thisAry.eventName;
                obj.eventName = eventName || "unkonw",
                obj.param = thisAry.param || ""
            }
            this.bridge.call('AFTrackEvent',JSON.stringify(obj));
        }

        static GATrackEvent(thisAry, callback){
            if(!this.isReady){
                return;
            }
            let obj = {}
            if(thisAry){
                let eventName = thisAry.eventName;
                obj.eventName = eventName || "unkonw",
                obj.param = thisAry.param || ""
            }
            this.bridge.call('GATrackEvent',JSON.stringify(obj));
        }

        static GetIdfa(thisAry,callback){
            console.log("tribalWarPrint:Native GetIdfa")
            if (!this.isReady) {
                return;
            }
            this.bridge.callWithBack((value) => {
                console.log("JS层的GetIdfa回调:"+value)
                if (callback) {
                    let jsonObj = JSON.parse(value);
                    this.playerId = jsonObj.idfa;
                    Laya.LocalStorage.setItem("AppsFlyerIdfa",this.playerId);
                    callback.call(null, jsonObj);
                }
            }, 'GetIdfa');
        }

        static OnAppHide() {
            console.log("laya进到后台")
            Laya.stage.event("ON_APP_HIDE");
        }

        static onAppResume() {
            console.log("laya回到前台")
            Laya.stage.event("ON_APP_SHOW");
        }

        static ShowAppReview(){
            console.log("zhise_laya_print 弹出评分窗口")
            if (!this.isReady)
                return;
            this.bridge.callWithBack(null, 'ReviewApp');
        }

        static ReviewAppCallBack(result){
            console.log("zhise_laya_print ReviewAppCallBack================================")
            Laya.LocalStorage.setItem("haveReviewApp",result)
        }

        static VibrateLong(){
            if (!this.isReady)
                return;
            this.bridge.call('VibrateLong');
        }

        static VibrateShort(){
            if (!this.isReady)
                return;
            this.bridge.call('VibrateShort');
        }
    }

    Native.conchIOS = "Conch-ios";
    Native.conchAndroid = "Conch-android";
    Native.playerId = null;

    if (Laya.Browser.window) {
        Laya.Browser.window.LayaNative = Native;
    }

    exports.Native = Native;

}(window.zs = window.zs || {}, Laya));